/*
 * EINT-core.c
 *
 *  Created on: 2015/07/07
 *      Author: h-sano
 */

/* Include file */
#include "../inc/EINT-core.h"
#include "../../DRIVER/inc/driver-common.h"
#include "../../DRIVER/inc/MAX10SoM-EINT.h"

/****************************************************************
void eint_enable
	This function external interrupt enable of component
inputs
	num  : EINT number
*****************************************************************/
void eint_enable( alt_u8 num )
{
	alt_u32 data;

	data = EINT_read( &EINT_board_info, EINT_ENA );

	data |= ( ENA_ENABLE << num );

	EINT_write( &EINT_board_info, EINT_ENA, data );
}

/****************************************************************
void eint_disable
	This function external interrupt disable of component
inputs
	num  : EINT number
*****************************************************************/
void eint_disable( alt_u8 num )
{
	alt_u32 data;

	data = EINT_read( &EINT_board_info, EINT_ENA );

	data &= ~( ENA_ENABLE << num );

	EINT_write( &EINT_board_info, EINT_ENA, data );

}

/****************************************************************
void eint_status
	This function external interrupt status read of component
inputs
	num  : EINT number
return value
	status of interrupt flag indicator process
*****************************************************************/
alt_u8 eint_status( alt_u8 num )
{
	alt_u8 data;

	data = (alt_u8)EINT_read( &EINT_board_info, EINT_STA );
	data = (data >> num) & 0x01;
	return data;
}

/****************************************************************
void eint_clear
	This function external interrupt clear of component
inputs
	num  : EINT number
*****************************************************************/
void eint_clear( alt_u8 num )
{
	alt_u32 data;

	data = EINT_read( &EINT_board_info, EINT_STA );

	data &= ~( 1 << num );

	EINT_write( &EINT_board_info, EINT_STA, data );
}

