/*
 *	PIO-core.c
 *
 *	Created on: 2015/05/22
 *		Author: KD
 */

/* Include file */
#include "../inc/PIO-core.h"
#include "../../DRIVER/inc/driver-common.h"
#include "../../DRIVER/inc/MAX10SoM-PIO.h"

void pio_direction( alt_u8 port_no, alt_u8 dir )
{
	int data, shift_bit;
	data = PIO_dir_read( port_no ) & 0x0000ffff;
	shift_bit = port_bit( port_no );
	data &= ~( 1 << shift_bit );
	PIO_dir_write( port_no, data | ( dir << shift_bit ));
}

alt_u16 pio_input( alt_u8 port_no )
{
	alt_u16 data, shift_bit;
	data = PIO_data_read( port_no ) & 0x0000ffff;
	shift_bit = port_bit( port_no );
	data = ( data >> shift_bit ) & 0x1;
	return data;
}

void pio_output( alt_u8 port_no, alt_u8 bit )
{
	int data, shift_bit;
	data = PIO_data_read( port_no ) & 0x0000ffff;
	shift_bit = port_bit( port_no );
	data &= ~( 1 << shift_bit );
	PIO_data_write( port_no, data | ( bit << shift_bit ));
}

void pio_request( alt_u8 port_no, alt_u8 port )
{
	int data, shift_bit;
	data = PIO_mux_read( port_no ) & 0x0000ffff;
	shift_bit = port_bit( port_no ) & 0x0000ffff;
	data &= ~( 1 << shift_bit );
	PIO_mux_write( port_no, data | ( port << shift_bit ));
}
