/*
 *	TIMER_core.c
 *
 *	Created on: 2015/05/27
 *		Author:KD
 */

/* Include file */
#include "../inc/TIMER-core.h"
#include "../../DRIVER/inc/driver-common.h"
#include "../../DRIVER/inc/MAX10SoM-TIMER.h"

char timer_start(char *device)
{
	alt_u8 i, match = 0;
	alt_u16 rdata;

	static struct TIMER_info *board_info = TIMER_board_info;

	for ( i = 0; ARRAY_SIZE( TIMER_board_info ); i++) {
		if ( strcmp( device, board_info->device ) == 0 ) {
			match = 1;
			break;
		}
		++board_info;
	}

	if ( !match )
		return -1;

	rdata = TIMER_read( board_info, TIMER_CTR );
	rdata &= ~( CTR_START );
	TIMER_write( board_info, TIMER_CTR, rdata | CTR_START );

	return 0;
}

char timer_stop(char *device)
{
	alt_u8 i, match = 0;
	alt_u16 rdata;
	static struct TIMER_info *board_info = TIMER_board_info;

	for ( i = 0; ARRAY_SIZE( TIMER_board_info ); i++) {
		if ( strcmp( device, board_info->device ) == 0 ) {
			match = 1;
			break;
		}
		++board_info;
	}

	if ( !match )
		return -1;

	rdata = TIMER_read( board_info, TIMER_CTR );
	rdata &= ~( CTR_STOP );
	TIMER_write( board_info, TIMER_CTR, rdata | CTR_STOP );

	return 0;

}

/* time : us order */
char timer_settime(char *device, alt_u32 time )
{
	alt_u8 i, match = 0;
	alt_u32 cnt;
	static struct TIMER_info *board_info = TIMER_board_info;

	for ( i = 0; ARRAY_SIZE( TIMER_board_info ); i++) {
		if ( strcmp( device, board_info->device ) == 0 ) {
			match = 1;
			break;
		}
		++board_info;
	}

	if ( !match )
		return -1;

	cnt = board_info->freq / 1000000;
	cnt *= time;

	TIMER_write( board_info, TIMER_PERL, TIMER_LOWBIT( cnt ));
	TIMER_write( board_info, TIMER_PERH, TIMER_HIGHBIT( cnt ));

	return 0;
}

char timer_config(char *device, alt_u32 config )
{
	alt_u8 i, match = 0;
	alt_u16 rdata;
	static struct TIMER_info *board_info = TIMER_board_info;

	for ( i = 0; ARRAY_SIZE( TIMER_board_info ); i++) {
		if ( strcmp( device, board_info->device ) == 0 ) {
			match = 1;
			break;
		}
		++board_info;
	}

	if ( !match )
		return -1;

	rdata = TIMER_read( board_info, TIMER_CTR );
	rdata &= ~( CTR_CONT );
	TIMER_write( board_info, TIMER_CTR, rdata | ( config << 1 ));

	return 0;

}
