/*
 *	WDT_core.c
 *
 *	Created on: 2015/05/27
 *		Author:KD
 */

/* Include file */
#include "../inc/WDT-core.h"
#include "../../DRIVER/inc/driver-common.h"
#include "../../DRIVER/inc/MAX10SoM-WDT.h"

char wdt_start(char *device)
{
	alt_u8 i, match = 0;
	alt_u16 rdata;

	static struct WDT_info *board_info = WDT_board_info;

	for ( i = 0; ARRAY_SIZE( WDT_board_info ); i++) {
		if ( strcmp( device, board_info->device ) == 0 ) {
			match = 1;
			break;
		}
		++board_info;
	}

	if ( !match )
		return -1;

	rdata = WDT_read( board_info, WDT_CTR );
	rdata &= ~( WDT_CTR_START );
	WDT_write( board_info, WDT_CTR, rdata | WDT_CTR_START );

	return 0;
}

char wdt_stop(char *device)
{
	alt_u8 i, match = 0;
	alt_u16 rdata;
	static struct WDT_info *board_info = WDT_board_info;

	for ( i = 0; ARRAY_SIZE( WDT_board_info ); i++) {
		if ( strcmp( device, board_info->device ) == 0 ) {
			match = 1;
			break;
		}
		++board_info;
	}

	if ( !match )
		return -1;

	rdata = WDT_read( board_info, WDT_CTR );
	rdata &= ~( WDT_CTR_STOP );
	WDT_write( board_info, WDT_CTR, rdata | WDT_CTR_STOP );

	return 0;

}

char wdt_clr( char *device )
{
	alt_u8 i, match = 0;

	static struct WDT_info *board_info = WDT_board_info;

	for ( i = 0; ARRAY_SIZE( WDT_board_info ); i++) {
		if ( strcmp( device, board_info->device ) == 0 ) {
			match = 1;
			break;
		}
		++board_info;
	}

	if ( !match )
		return -1;

	WDT_init( board_info );
	wdt_start( board_info->device );

	return 0;
}
