/*
 * MAX1-SoM-EINT.h
 *
 *  Created on: 2015/05/22
 *      Author: KD
 */

#ifndef _MAX10_SOM_EINT_H_
#define _MAX10_SOM_EINT_H_

#include "sys/alt_irq.h"
#include <io.h>
#include "alt_types.h"
#include "../../int.h"

/* EINT REGISTER of MAX10SoM */

/* ADDRESS OFFSET */
#define EINT_ENA	(0)
#define EINT_STA	(1)
#define EINT_MODE	(2)
#define EINT_POL	(3)

/* BIT DEFINE */
/* ENA register bit */
#define ENA_ENABLE	(1)
#define ENA_DISABLE	(0)

/* STA register bit */
#define STA_CLR		(0)

/* MODE register bit */
#define MODE_EDGE	(1)
#define MODE_LEVEL	(0)

/* POL register bit */
#define POL_HIGH	(1)
#define POL_LOW		(0)

enum {
	EINT0, EINT1, EINT2, EINT3, EINT4, EINT5, EINT6, EINT7, EINTEND,
};

#define EINT_NUM(x)	x + 1

/* EINT infomation */
struct EINT_dev_info {
	alt_u8 int_mode;
	alt_u8 int_pol;
	alt_u8 num;
	struct irq_info irq;
};

struct EINT_info {
	alt_u32 address;
	struct EINT_dev_info dev_info[EINTEND];
};

extern struct EINT_info EINT_board_info;

/* FUNCTION OF MAX10SoM EINT */
/* EINT initial */

extern void EINT_init(struct EINT_info *board_info,alt_u8 num);
extern void EINT_write(struct EINT_info *board_info, alt_u8 addr, alt_u16 data);
extern alt_u16 EINT_read(struct EINT_info *board_info, alt_u8 addr);

#endif /* _MAX10_SOM_EINT_H_ */
