/*
 * 	MAX10SoM-PIO.h
 *
 *	Created on: 2015/05/22
 *	Author: Author(KD)
 */

#ifndef _MAX10SOM_PIO_H_
#define _MAX10SOM_PIO_H_

#include "alt_types.h"

enum {
	PA0,	// UART0_TXD
	PA1,	// UART0_RXD
	PA2,	// UART0_RTS
	PA3,	// UART0_CTS
	PA4,	// UART1_TXD
	PA5,	// UART1_RXD
	PA6,	// UART1_RTS
	PA7,	// UART1_CTS
	PA8,	// SPI0_SCLK
	PA9,	// Reserve
	PA10,	// SPI0_MOSI
	PA11,	// SPI0_MISO
	PA12,	// SPI1_SCLK
	PA13,	// Reserve
	PA14,	// SPI1_MOSI
	PA15,	// SPI1_MISO

	PB0,	// SPI2_SCLK
	PB1,	// Reserve
	PB2,	// SPI2_MOSI
	PB3,	// SPI2_MISO
	PB4,	// SPI3_SCLK
	PB5,	// Reserve
	PB6,	// SPI3_MOSI
	PB7,	// SPI3_MISO
	PB8,	// PWM0
	PB9,	// PWM1
	PB10,	// PWM2
	PB11,	// Reserve
	PB12,	// LCD_CLK
	PB13,	// LCD_HSD
	PB14,	// LCD_VSD
	PB15,	// LCD_DEN

	PC0,	// LCD_D0
	PC1,	// LCD_D1
	PC2,	// LCD_D2
	PC3,	// LCD_D3
	PC4,	// LCD_D4
	PC5,	// LCD_D5
	PC6,	// LCD_D6
	PC7,	// LCD_D7
	PC8,	// LCD_D8
	PC9,	// LCD_D9
	PC10,	// LCD_D10
	PC11,	// LCD_D11
	PC12,	// LCD_D12
	PC13,	// LCD_D13
	PC14,	// LCD_D14
	PC15,	// LCD_D15

	PD0,	// INT0
	PD1,	// INT1
	PD2,	// INT2
	PD3,	// INT3
	PD4,	// INT4
	PD5,	// INT5
	PD6,	// INT6
	PD7,	// INT7
	PD8,	// Reserve
	PD9,	// Reserve
	PD10,	// Reserve
	PD11,	// Reserve
	PD12,	// Reserve
	PD13,	// Reserve
	PD14,	// Reserve
	PD15,	// Reserve

	PE0,	// I2C_SCL
	PE1, 	// I2C_SDA

	PORT_END,	// PORT_NUM
};

#define PIO_DIR_IN	0
#define PIO_DIR_OUT	1
#define PORT_PIO	0
#define PORT_FUNC	1

#define port_add(port_no)	(port_no/16)
#define port_bit(port_no)	(port_no%16)

extern void PIO_data_write(alt_u8 port_no, alt_u16 data);
extern void PIO_dir_write(alt_u8 port_no, alt_u16 data);
extern alt_u16 PIO_data_read(alt_u8 port_no);
extern alt_u16 PIO_dir_read(alt_u8 port_no);
extern void PIO_mux_write(alt_u8 port_no, alt_u16 data);
extern alt_u16 PIO_mux_read(alt_u8 port_no);


#endif /* _MAX10SOM_PIO_H_ */
