/*
 * MAX10SoM-PWM.h
 *
 *  Created on: 2015/04/30
 *      Author: Jinso(Nui)
 */

#ifndef MAX10SOM_PWM_H_
#define MAX10SOM_PWM_H_

#include <io.h>
#include "system.h"
#include "alt_types.h"
#include "../../config.h"

/* PWM REGISTER of MAX10SoM */
/* BASE ADDRESS */
#define PWM0_BASE					PWM_0_BASE
#define PWM1_BASE					PWM_1_BASE

/* ADDRESS OFFSET */
#define PWM_CTR						(0)
#define PWM_DIV						(1)
#define PWM_PER						(2)
#define	PWM_DUTY					(3)

/* BIT DEFINE */
/* PWM_CTR register bit */
#define CTR_CNT						(0x04)
#define CTR_OUT						(0x10)
/* PWM_DIV register bit */

/* PWM_PER register bit */

/* PWM_DUTY register bit */

/* PARAMETER DEFINE */

/*Servo parameter*/
#define SERVO_PULSE_WIDTH			(0.0225)
#define SERVO_DUTY_01				(0.00075)
#define SERVO_DUTY_02				(0.0015)
#define SERVO_DUTY_03				(0.00225)

/* PWM device information */
struct PWM_dev_info {
	char *device_name;
};

struct PWM_info {
	char *device;
	alt_u32 address;
	alt_u32 clk;
	alt_u32 speed;
	struct PWM_dev_info dev_info;
};

extern struct PWM_info PWM_board_info[CONFIG_PWM_NUM];

/* FUNCTION OF MAX10SoM PWM  */
void PWM_init(struct PWM_info *board_info);
alt_u16 PWM_read(struct PWM_info *board_info, alt_u8 offset);
void PWM_write(struct PWM_info *board_info, alt_u8 offset, alt_u16 data);


#endif /* MAX10SOM_PWM_H_ */
