/*
 *	MAX10SoM-TIMER.h
 *
 *	Created on: 2015/05/21
 *		Author: KD
 */

#ifndef MAX10SOM_TIMER_H_
#define MAX10SOM_TIMER_H_

#include "alt_types.h"
#include <io.h>
#include "../../config.h"
#include "../../int.h"

/* ADDRESS OFFSET */
#define TIMER_STR	(0)
#define TIMER_CTR	(1)
#define TIMER_PERL	(2)
#define TIMER_PERH	(3)
#define TIMER_SNPL	(4)
#define TIMER_SNPH	(5)

/* BIT DEFINE */
/* STR register */
#define STR_TO		(1 << 0)
#define STR_RUN		(1 << 1)

/* CTR register */
#define CTR_ITO		(1 << 0)
#define CTR_CONT	(1 << 1)
#define CTR_START	(1 << 2)
#define CTR_STOP	(1 << 3)

enum {
	TIMER0, TIMER1, TIMER2,
};

#define TIMER_HIGHBIT(x)	(( x >> 16 ) & 0x0000ffff )
#define TIMER_LOWBIT(x)		( x & 0x0000ffff )

#define TIMER_MODE_CONT		1
#define TIMER_MODE_ONCE		0

/* TIMER infomation */
struct TIMER_info {
	char *device;
	alt_u32 address;
	struct irq_info irq;
	alt_u32 freq;
	alt_u8 timer_mode;
	alt_u32 period;
};

extern struct TIMER_info TIMER_board_info[CONFIG_TIMER_NUM];

/* FUNCTION OF MAX10SoM TIMER */
/* TIMER initial */
extern void TIMER_init(struct TIMER_info *board_info);
extern void TIMER_write(struct TIMER_info *board_info, alt_u8 add, alt_u16 data);
extern alt_u16 TIMER_read(struct TIMER_info *board_info, alt_u8 add);


#endif /* MAX10SOM_TIMER_H_ */
