
#ifndef _MAX10SOM_WDT_H_
#define _MAX10SOM_WDT_H_

#include "alt_types.h"
#include "../../config.h"
#include <io.h>

/* ADDRESS OFFSET */
#define WDT_STR	(0)
#define WDT_CTR		(1)
#define WDT_PERL	(2)
#define WDT_PERH	(3)

/* BIT DEFINE */
/* STR register */
#define WDT_STR_TO		(1 << 0)
#define WDT_STR_RUN		(1 << 1)

/* CTR register */
#define WDT_CTR_START	(1 << 2)
#define WDT_CTR_STOP	(1 << 3)

#define WDT_HIGHBIT(x)	(( x >> 16 ) & 0x0000ffff )
#define WDT_LOWBIT(x)		( x & 0x0000ffff )

/* WDT infomation */
struct WDT_info {
	char *device;
	alt_u32 address;
	alt_u32 freq;
	alt_u32 period;
};

extern struct WDT_info WDT_board_info[1];
	
/* FUNCTION OF MAX10SoM WDT */
/* WDT initial */
extern void WDT_init(struct WDT_info *board_info);
extern void WDT_write(struct WDT_info *board_info, alt_u8 add, alt_u16 data);
extern alt_u16 WDT_read(struct WDT_info *board_info, alt_u8 add);

#endif /* _MAX10SOM_WDT_H_ */

