/*
 * MAX10SoM-EINT.c
 *
 *  Created on: 2015/05/22
 *      Author: KD
 */

/* Include file */
#include "../inc/driver-common.h"
#include "../inc/MAX10SoM-EINT.h"

void EINT_init( struct EINT_info *board_info, alt_u8 num )
{
	alt_u32 base_add = board_info->address;
	struct EINT_dev_info  dev_info = board_info->dev_info[num];
	alt_u32 data = 0;

	/* EINT ALL Disable */
	IOWR( base_add, EINT_ENA, 0 );

	/* Mode Setting */
	data = IORD( base_add, EINT_MODE );
	data |= ( dev_info.int_mode << dev_info.num );

	IOWR( base_add, EINT_MODE, data );

	/* POL Setting */
	data = IORD( base_add, EINT_POL );
	data |= ( dev_info.int_pol << dev_info.num );

	IOWR( base_add, EINT_POL, data );

	if ( dev_info.irq.isr != NULL)
		irq_request( &dev_info.irq );

}

void EINT_write( struct EINT_info *board_info, alt_u8 addr, alt_u16 data )
{
	alt_u32 base_add = board_info->address;

	IOWR( base_add, addr, data );

}

alt_u16 EINT_read( struct EINT_info *board_info, alt_u8 addr )
{
	alt_u32 base_add = board_info->address;

	return (alt_u16)IORD( base_add, addr );


}
