/*
 * 	MAX10SoM-TIMER.c
 *
 * 	Created on: 2015/05/21
 * 		Author:KD
 */

/* Include file */
#include "../inc/driver-common.h"
#include "../inc/MAX10SoM-TIMER.h"

void TIMER_init(struct TIMER_info *board_info)
{
	alt_u32 base_add = board_info->address;
	alt_u32 period = board_info->period;
	alt_u32 data = 0;

	IOWR( base_add, TIMER_CTR, 0 );

	IOWR( base_add, TIMER_PERL, TIMER_LOWBIT( period ));
	IOWR( base_add, TIMER_PERH, TIMER_HIGHBIT( period ));

	if ( board_info->irq.isr != NULL ) {
		data = CTR_ITO;
		irq_request( &board_info->irq );
	}

	data |= board_info->timer_mode;

	IOWR( base_add, TIMER_CTR, data );
}

void TIMER_write(struct TIMER_info *board_info, alt_u8 add, alt_u16 data)
{
	alt_u32 base_add = board_info->address;

	IOWR( base_add, add, data );
}

alt_u16 TIMER_read(struct TIMER_info *board_info, alt_u8 add)
{
	alt_u32 base_add = board_info->address;

	return IORD( base_add, add );
}
