/*
 *	MAX10SoM-WDT.c
 *
 *	Created on: 2015/06/08
 *		Author: KD
 */

/* Include file */
#include "../inc/driver-common.h"
#include "../inc/MAX10SoM-WDT.h"

void WDT_init(struct WDT_info *board_info)
{
	alt_u32 base_add = board_info->address;
	alt_u32 period = board_info->period;

	IOWR( base_add, WDT_CTR, 0 );

	IOWR( base_add, WDT_PERL, WDT_LOWBIT( period ));
	IOWR( base_add, WDT_PERH, WDT_HIGHBIT( period ));


}

void WDT_write(struct WDT_info *board_info, alt_u8 add, alt_u16 data)
{
	alt_u32 base_add = board_info->address;

	IOWR( base_add, add, data );

}

alt_u16 WDT_read(struct WDT_info *board_info, alt_u8 add)
{
	alt_u32 base_add = board_info->address;

	return IORD( base_add, add );

}
