/*
 *	board_init.c
 *
 *	Created on: 2015/04/30
 * 		Author: jinso
 * 	Mofidy on: 2015/05/21
 * 		Author: KD
 */

/* Include file */
#include "board_init.h"

/* Variable declaration */
struct I2C_info I2C_board_info[CONFIG_I2C_NUM] = {
#if CONFIG_FUNC_I2C0
	[0] = {
		.device		=	I2C_0_NAME,
		.address	=	I2C_0_BASE,
		.clk		=	80000000,
		.speed		=	100000,		// 100KHz
		.irq =	{
				.ic_id	=	I2C_0_IRQ_INTERRUPT_CONTROLLER_ID,
				.irq	=	I2C_0_IRQ,
				.isr	=	NULL,
		},
#if CONFIG_DEV_I2C_RTC_8564
		.dev_info[0] = {
			.device_name	=	"RTC_8564",
			.slave_addr		=	0x51,
		},
#endif
#if CONFIG_DEV_I2C_ADT7410
		.dev_info[1] = {
			.device_name	=	"ADT7410",
			.slave_addr		=	0x48,
		},
#endif
#if CONFIG_DEV_I2C_MCP23017
		.dev_info[2] = {
			.device_name	=	"MCP23017",
			.slave_addr		=	0x20,
		},
#endif
#if CONFIG_DEV_I2C_BR24G32
		.dev_info[3] = {
			.device_name	=	"BR24G32",
			.slave_addr		=	0x50,
			.config			=	I2C_ADD16,
		},
#endif
	},
#endif /* CONFIG_FUNC_I2C0 */

};

struct SPI_info SPI_board_info[CONFIG_SPI_NUM] = {
#if CONFIG_FUNC_SPI0
		[0] = {
				.device		= SPI_0_NAME,
				.address	= SPI_0_BASE,
				.clk		= 80000000,
				.speed		= 20000000,
				.spi_mode	= SPI_MODE0,
				.irq =	{
						.ic_id	=	SPI_0_IRQ_INTERRUPT_CONTROLLER_ID,
						.irq	=	SPI_0_IRQ,
						.isr	=	NULL,
				},
				.dev_info[0] = {
						.device_name	= "W5500",
						.pio_cs			= PA9,
				},
		},
#endif

#if CONFIG_FUNC_SPI1
		[1] = {
				.device		= SPI_1_NAME,
				.address	= SPI_1_BASE,
				.clk		= 80000000,
				.speed		= 10000000,
				.spi_mode	= SPI_MODE3,
				.irq =	{
						.ic_id	=	SPI_1_IRQ_INTERRUPT_CONTROLLER_ID,
						.irq	=	SPI_1_IRQ,
						.isr	=	NULL,
				},
				.dev_info[0] = {
						.device_name	= "ADC108S022",
						.pio_cs			= PA13,
				},
		},
#endif

#if CONFIG_FUNC_SPI2
		[2] = {
				.device		= SPI_2_NAME,
				.address	= SPI_2_BASE,
				.clk		= 80000000,
				.speed		= 20000000,
				.spi_mode	= SPI_MODE1,
				.irq =	{
						.ic_id	=	SPI_2_IRQ_INTERRUPT_CONTROLLER_ID,
						.irq	=	SPI_2_IRQ,
						.isr	=	NULL,
				},
				.dev_info[0] = {
						.device_name	= "DAC082S085",
						.pio_cs			= PB1,
				},
		},
#endif

#if CONFIG_FUNC_SPI3
		[3] = {
				.device		= SPI_3_NAME,
				.address	= SPI_3_BASE,
				.clk		= 80000000,
				.speed		= 2000000,
				.spi_mode	= SPI_MODE3,
				.irq =	{
						.ic_id	=	SPI_3_IRQ_INTERRUPT_CONTROLLER_ID,
						.irq	=	SPI_3_IRQ,
						.isr	=	NULL,
				},
				.dev_info[0] = {
						.device_name	= "TSC2046",
						.pio_cs			= PB5,
				},
		},
#endif
};

struct PWM_info PWM_board_info[CONFIG_PWM_NUM] = {
#if CONFIG_FUNC_PWM0
		[0] = {
			.device		=	PWM_0_NAME,
			.address	=	PWM_0_BASE,
			.clk		=	80000000,
			.speed		=	3906,
			.dev_info	= {
				.device_name	=	"BUZZER",
			},
		},
#endif
#if CONFIG_FUNC_PWM1
		[1] = {
			.device		=	PWM_1_NAME,
			.address	=	PWM_1_BASE,
			.clk		=	80000000,
			.speed		=	46,
			.dev_info 	= {
				.device_name	=	"SERVO",
			},
		},
#endif
#if CONFIG_FUNC_PWM2
		[2] = {
			.device		=	PWM_2_NAME,
			.address	=	PWM_2_BASE,
			.clk		=	80000000,
			.speed		=	100000,
			.dev_info	= {
					.device_name	=	"TPS61165",
			},
		},
#endif
};

struct UART_info UART_board_info[CONFIG_UART_NUM] = {
#if CONFIG_DEBUG_USE_UART
#if CONFIG_FUNC_UART0
		[0] = {
			.device		=	UART_0_NAME,
			.address	=	UART_0_BASE,
			.clk		=	80000000,
			.baud		=	115200,
			.irq		=	{
					.irq		=	UART_0_IRQ,
					.ic_id		=	UART_0_IRQ_INTERRUPT_CONTROLLER_ID,
					.isr		=	(void *)uart0_irq_event,
					.irq_event	=	(void *)uart_cmd_event,
			},
			.dev_info[0]	= {
					.device_name	=	"UART0",
			},
		},
#endif
#else
#if CONFIG_FUNC_UART1
		[1] = {
			.device		=	UART_1_NAME,
			.address	=	UART_1_BASE,
			.clk		=	80000000,
			.baud		=	115200,
			.irq		=	{
					.irq		=	UART_1_IRQ,
					.ic_id		=	UART_1_IRQ_INTERRUPT_CONTROLLER_ID,
					.isr		=	(void *)uart1_irq_event,
					.irq_event	=	(void *)uart1_event,
			},
			.dev_info[0]	= {
					.device_name	=	"UART1",
			},
		},
#endif
#endif /* CONFIG_DEBUG_USE_UART */
};

struct TIMER_info TIMER_board_info[CONFIG_TIMER_NUM] = {
#if CONFIG_FUNC_TIMER0
	[0] = {
		.device		=	TIMER_0_NAME,
		.address	=	TIMER_0_BASE,
		.irq		=	{
				.irq	=	TIMER_0_IRQ,
				.ic_id	=	TIMER_0_IRQ_INTERRUPT_CONTROLLER_ID,
				.isr	=	(void *)timer0_irq_event,
		},
		.freq		=	TIMER_0_FREQ,
		.timer_mode	=	0,
		.period		=	TIMER_0_FREQ / 1000000,
	},
#endif
#if CONFIG_FUNC_TIMER1
	[1] = {
		.device		=	TIMER_1_NAME,
		.address	=	TIMER_1_BASE,
		.irq		=	{
				.irq		=	TIMER_1_IRQ,
				.ic_id		=	TIMER_1_IRQ_INTERRUPT_CONTROLLER_ID,
				.isr		=	(void *)timer1_irq_event,
		},
		.freq		=	TIMER_1_FREQ,
		.timer_mode	=	2,
		.period		=	TIMER_1_FREQ / 10000,
	},
#endif
#if CONFIG_FUNC_TIMER2
	[2] = {
		.device		=	TIMER_2_NAME,
		.address	=	TIMER_2_BASE,
		.irq		=	{
				.irq	=	TIMER_2_IRQ,
				.ic_id	=	TIMER_2_IRQ_INTERRUPT_CONTROLLER_ID,
				.isr	=	(void *)timer2_irq_event,
		},
		.freq		=	TIMER_2_FREQ,
		.timer_mode	=	0,
		.period		=	TIMER_2_FREQ / 1000000,
	},
#endif
};

struct WDT_info WDT_board_info[1] = {
#if CONFIG_FUNC_WDT
	[0] = {
		.device		=	WDT_NAME,
		.address	=	WDT_BASE,
		.freq		=	WDT_FREQ,
		.period		=	TIME_BASE(WDT_FREQ) * CONFIG_WDT_TIME,
	},
#endif
};

struct EINT_info EINT_board_info = {
	.address	=	EINT_BASE,
#if CONFIG_FUNC_EINT0
	.dev_info[0] = {
		.num		=	EINT0,
		.int_mode	=	MODE_LEVEL,
		.int_pol	=	POL_HIGH,
		.irq	=	{
				.irq	=	EINT_NUM(EINT0),
				.ic_id	=	0,
				.isr	=	(void *)eint0_irq_event,
		},
	},
#endif
#if CONFIG_FUNC_EINT1
	.dev_info[1] = {
		.num		=	EINT1,
		.int_mode	=	MODE_LEVEL,
		.int_pol	=	POL_HIGH,
		.irq	=	{
				.irq	=	EINT_NUM(EINT1),
				.ic_id	=	0,
				.isr	=	(void *)eint1_irq_event,
		},
	},
#endif
#if CONFIG_FUNC_EINT2
	.dev_info[2] = {
		.num		=	EINT2,
		.int_mode	=	MODE_LEVEL,
		.int_pol	=	POL_HIGH,
		.irq	=	{
				.irq	=	EINT_NUM(EINT2),
				.ic_id	=	0,
				.isr	=	(void *)eint2_irq_event,
		},
	},
#endif
#if CONFIG_FUNC_EINT3
	.dev_info[3] = {
		.num		=	EINT3,
		.int_mode	=	MODE_LEVEL,
		.int_pol	=	POL_HIGH,
		.irq	=	{
				.irq	=	EINT_NUM(EINT3),
				.ic_id	=	0,
				.isr	=	(void *)eint3_irq_event,
		},
	},
#endif
#if CONFIG_FUNC_EINT4
	.dev_info[4] = {
		.num		=	EINT4,
		.int_mode	=	MODE_LEVEL,
		.int_pol	=	POL_HIGH,
		.irq	=	{
				.irq	=	EINT_NUM(EINT4),
				.ic_id	=	0,
				.isr	=	(void *)eint4_irq_event,
		},
	},
#endif
#if CONFIG_FUNC_EINT5
	.dev_info[5] = {
		.num		=	EINT5,
		.int_mode	=	MODE_LEVEL,
		.int_pol	=	POL_HIGH,
		.irq	=	{
				.irq	=	EINT_NUM(EINT5),
				.ic_id	=	0,
				.isr	=	(void *)eint5_irq_event,
		},
	},
#endif
#if CONFIG_FUNC_EINT6
	.dev_info[6] = {
		.num		=	EINT6,
		.int_mode	=	MODE_LEVEL,
		.int_pol	=	POL_HIGH,
		.irq	=	{
				.irq	=	EINT_NUM(EINT6),
				.ic_id	=	0,
				.isr	=	(void *)eint6_irq_event,
		},
	},
#endif
#if CONFIG_FUNC_EINT7
	.dev_info[7] = {
		.num		=	EINT7,
		.int_mode	=	MODE_LEVEL,
		.int_pol	=	POL_HIGH,
		.irq	=	{
				.irq	=	EINT_NUM(EINT7),
				.ic_id	=	0,
				.isr	=	(void *)eint7_irq_event,
		},
	},
#endif
};

void pin_func_init( void )
{
	int i;

	/* ALL Pin PIO Input Initilize Setting */
	for ( i = 0; i < PORT_END; i++) {
		pio_request( i, PORT_PIO );
		pio_direction( i, PIO_DIR_IN );
	}

#if CONFIG_FUNC_I2C0
	pio_request(PE0, PORT_FUNC);	// SCL
	pio_request(PE1, PORT_FUNC);	// SDA
#endif

#if CONFIG_FUNC_SPI0
	pio_request(PA8, PORT_FUNC);	// CLK
	pio_request(PA9, PORT_PIO);	// CS
	pio_direction(PA9, PIO_DIR_OUT);
	pio_output(PA9, 1);		// default High
	pio_request(PA10, PORT_FUNC);	// MOSI
	pio_request(PA11, PORT_FUNC);	// MISO
#endif

#if CONFIG_FUNC_SPI1
	pio_request(PA12, PORT_FUNC);	// CLK
	pio_request(PA13, PORT_PIO);	// CS
	pio_direction(PA13, PIO_DIR_OUT);
	pio_output(PA13, 1);		// default High
	pio_request(PA14, PORT_FUNC);	// MOSI
	pio_request(PA15, PORT_FUNC);	// MISO
#endif

#if CONFIG_FUNC_SPI2
	pio_request(PB0, PORT_FUNC);	// CLK
	pio_request(PB1, PORT_PIO);	// CS
	pio_direction(PB1, PIO_DIR_OUT);
	pio_output(PB1, 1);		// default High
	pio_request(PB2, PORT_FUNC);	// MOSI
#endif

#if CONFIG_FUNC_SPI3
	pio_request(PB4, PORT_FUNC);	// CLK
	pio_request(PB5, PORT_PIO);	// CS
	pio_direction(PB5, PIO_DIR_OUT);
	pio_output(PB5, 1);		// default High
	pio_request(PB6, PORT_FUNC);	// MOSI
	pio_request(PB7, PORT_FUNC);	// MISO
#endif

#if CONFIG_FUNC_PWM0
	pio_request(PB8, PORT_FUNC);	// pwm
#endif

#if CONFIG_FUNC_PWM1
	pio_request(PB9, PORT_FUNC);	// pwm
#endif

#if CONFIG_FUNC_PWM2
	pio_request(PB10, PORT_FUNC);	// pwm
#endif

#if CONFIG_FUNC_UART0
	pio_request(PA0, PORT_FUNC);	// TXD
	pio_request(PA1, PORT_FUNC);	// RXD
#endif

#if CONFIG_FUNC_UART1
	pio_request(PA4, PORT_FUNC);	// TXD
	pio_request(PA5, PORT_FUNC);	// RXD
#endif

#if CONFIG_FUNC_LCDC
	pio_request(PB12, PORT_FUNC);	// CLK
	pio_request(PB13, PORT_FUNC);	// HSD
	pio_request(PB14, PORT_FUNC);	// VSD
	pio_request(PB15, PORT_FUNC);	// DEN
	pio_request(PC0, PORT_FUNC);	// D0
	pio_request(PC1, PORT_FUNC);	// D1
	pio_request(PC2, PORT_FUNC);	// D2
	pio_request(PC3, PORT_FUNC);	// D3
	pio_request(PC4, PORT_FUNC);	// D4
	pio_request(PC5, PORT_FUNC);	// D5
	pio_request(PC6, PORT_FUNC);	// D6
	pio_request(PC7, PORT_FUNC);	// D7
	pio_request(PC8, PORT_FUNC);	// D8
	pio_request(PC9, PORT_FUNC);	// D9
	pio_request(PC10, PORT_FUNC);	// D10
	pio_request(PC11, PORT_FUNC);	// D11
	pio_request(PC12, PORT_FUNC);	// D12
	pio_request(PC13, PORT_FUNC);	// D13
	pio_request(PC14, PORT_FUNC);	// D14
	pio_request(PC15, PORT_FUNC);	// D15
#endif

#if CONFIG_FUNC_EINT0
	pio_request(PD0, PORT_FUNC);	// EINT0
#endif

#if CONFIG_FUNC_EINT1
	pio_request(PD1, PORT_FUNC);	// EINT1
#endif

#if CONFIG_FUNC_EINT2
	pio_request(PD2, PORT_FUNC);	// EINT2
#endif

#if CONFIG_FUNC_EINT3
	pio_request(PD3, PORT_FUNC);	// EINT3
#endif

#if CONFIG_FUNC_EINT4
	pio_request(PD4, PORT_FUNC);	// EINT4
#endif

#if CONFIG_FUNC_EINT5
	pio_request(PD5, PORT_FUNC);	// EINT5
#endif

#if CONFIG_FUNC_EINT6
	pio_request(PD6, PORT_FUNC);	// EINT6
#endif

#if CONFIG_FUNC_EINT7
	pio_request(PD7, PORT_FUNC);	// EINT7
#endif
}

/****************************************************************
void board_init
		This function initial devices
inputs
		nothing
return value
		nothing
*****************************************************************/
void board_init(){
	/* PIO initial */
	pin_func_init();

	/* TIMER initial */
#if CONFIG_FUNC_TIMER0
	TIMER_init(&TIMER_board_info[0]);
#endif

#if CONFIG_FUNC_TIMER1
	TIMER_init(&TIMER_board_info[1]);
#endif

#if CONFIG_FUNC_TIMER2
	TIMER_init(&TIMER_board_info[2]);
#endif


	/* I2C device initial */
#if CONFIG_FUNC_I2C0
	I2C_init(&I2C_board_info[0]);
#endif

	/* SPI device initial */
#if CONFIG_FUNC_SPI0
	SPI_init(&SPI_board_info[0]);
#endif

#if CONFIG_FUNC_SPI1
	SPI_init(&SPI_board_info[1]);
#endif

#if CONFIG_FUNC_SPI2
	SPI_init(&SPI_board_info[2]);
#endif

#if CONFIG_FUNC_SPI3
	SPI_init(&SPI_board_info[3]);
#endif

/* UART device initial */
#if CONFIG_DEBUG_USE_UART
#if CONFIG_FUNC_UART0
	uart_init(&UART_board_info[0]);
#endif
#else
#if CONFIG_FUNC_UART1
	uart_init(&UART_board_info[1]);
#endif
#endif /* CONFIG_DEBUG_USE_UART */

/* PWM device initial */
#if CONFIG_FUNC_PWM0
	/* Buzzer */
	PWM_init(&PWM_board_info[0]);
#endif
#if CONFIG_FUNC_PWM1
	/* Servo */
	PWM_init(&PWM_board_info[1]);
#endif
#if CONFIG_FUNC_PWM2
	/* back light */
	PWM_init(&PWM_board_info[2]);
#endif

#if CONFIG_FUNC_EINT0
	EINT_init(&EINT_board_info,EINT0);
#endif

#if CONFIG_FUNC_EINT1
	EINT_init(&EINT_board_info,EINT1);
#endif

#if CONFIG_FUNC_EINT2
	EINT_init(&EINT_board_info,EINT2);
#endif

#if CONFIG_FUNC_EINT3
	EINT_init(&EINT_board_info,EINT3);
#endif

#if CONFIG_FUNC_EINT4
	EINT_init(&EINT_board_info,EINT4);
#endif

#if CONFIG_FUNC_EINT5
	EINT_init(&EINT_board_info,EINT5);
#endif

#if CONFIG_FUNC_EINT6
	EINT_init(&EINT_board_info,EINT6);
#endif

#if CONFIG_FUNC_EINT7
	EINT_init(&EINT_board_info,EINT7);
#endif

}
