/*
 *	board_info.h
 *
 *	Created on: 2015/04/30
 *		Author: KD
 */

#ifndef _BOARD_INFO_H_
#define _BOARD_INFO_H_

/* Include file */
/* Header file of C standard */
#include <string.h>
#include <stddef.h>
#include <stdio.h>

/* Include api-core */
#include "DRIVER/inc/driver-common.h"
#include "API-CORE/inc/I2C-core.h"
#include "API-CORE/inc/SPI-core.h"
#include "API-CORE/inc/PWM-core.h"
#include "API-CORE/inc/UART-core.h"
#include "API-CORE/inc/PIO-core.h"
#include "API-CORE/inc/TIMER-core.h"
#include "API-CORE/inc/WDT-core.h"

/* Include driver*/
#include "DRIVER/inc/MAX10SoM-I2C.h"
#include "DRIVER/inc/MAX10SoM-SPI.h"
#include "DRIVER/inc/MAX10SoM-PWM.h"
#include "DRIVER/inc/MAX10SoM-UART.h"
#include "DRIVER/inc/MAX10SoM-EINT.h"
#include "DRIVER/inc/MAX10SoM-PIO.h"
#include "DRIVER/inc/MAX10SoM-TIMER.h"
#include "DRIVER/inc/MAX10SoM-WDT.h"

/* Include configuration file */
#include "config.h"
/* Include IRQ file */
#include "int.h"

/* Include Nios II Header file */
#include "system.h"
#include "alt_types.h"

/* IRQ Event */
extern void timer0_irq_event(void* context, alt_u32 id);
extern void timer1_irq_event(void* context, alt_u32 id);
extern void timer2_irq_event(void* context, alt_u32 id);
extern void uart_cmd_event( void* context );
extern void uart1_event( void* context );
extern void eint0_irq_event( void* context, alt_u32 id);
extern void eint1_irq_event( void* context, alt_u32 id);
extern void eint2_irq_event( void* context, alt_u32 id);
extern void eint3_irq_event( void* context, alt_u32 id);
extern void eint4_irq_event( void* context, alt_u32 id);
extern void eint5_irq_event( void* context, alt_u32 id);
extern void eint6_irq_event( void* context, alt_u32 id);
extern void eint7_irq_event( void* context, alt_u32 id);

extern void board_init();


#endif /* _BOARD_INFO_H_ */
