/*
 * config.h
 *
 *  Created on: 2015/04/30
 *      Author: KD
 */

#ifndef _CONFIG_H_
#define _CONFIG_H_

#define CONFIG_DEBUG_UART0		0
#define CONFIG_DEBUG_UART1		1

/* STDIO use UART ch */
#define CONFIG_DEBUG_USE_UART		CONFIG_DEBUG_UART1

/* Configuration for using devices */
#define CONFIG_DEV_I2C_NUM			4
#define CONFIG_DEV_I2C_RTC_8564		1
#define CONFIG_DEV_I2C_BR24G32		1
#define CONFIG_DEV_I2C_ADT7410		1
#define CONFIG_DEV_I2C_MCP23017		1

#define CONFIG_DEV_SPI_W5500		1
#define CONFIG_DEV_SPI_ADC108S022	1
#define CONFIG_DEV_SPI_DAC082S085	1
#define CONFIG_DEV_SPI_TSC2046		0

#define CONFIG_DEV_PWM_BUZZER		1
#define CONFIG_DEV_PWM_SERVO		1
#define CONFIG_DEV_PWM_BACKLIGHT	0

#define CONFIG_DEV_UART_RS232C		1
#define CONFIG_DEV_UART_USB			1

#define CONFIG_DEV_LCD				0

/* Ext INT Configuration */
#define CONFIG_FUNC_EINT0	0
#define CONFIG_FUNC_EINT1	0
#define CONFIG_FUNC_EINT2	0
#define CONFIG_FUNC_EINT3	0
#define CONFIG_FUNC_EINT4	0
#define CONFIG_FUNC_EINT5	0
#define CONFIG_FUNC_EINT6	0
#define CONFIG_FUNC_EINT7	0

/* Configuration for function setting for IF */
/*  I2C */
#define CONFIG_I2C_NUM		1
#define CONFIG_I2C_DEV CONFIG_DEV_I2C_RTC_8564 | CONFIG_DEV_I2C_BR24G32 | CONFIG_DEV_I2C_ADT7410 | CONFIG_DEV_I2C_MCP23017
#if	CONFIG_I2C_DEV
#define	CONFIG_FUNC_I2C0	1
#else
#define	CONFIG_FUNC_I2C0	0
#endif

/* SPI */
#define CONFIG_SPI_NUM		3
#if	CONFIG_DEV_SPI_W5500
#define	CONFIG_FUNC_SPI0	1
#else
#define	CONFIG_FUNC_SPI0	0
#endif

#if	CONFIG_DEV_SPI_ADC108S022
#define	CONFIG_FUNC_SPI1	1
#else
#define	CONFIG_FUNC_SPI1	0
#endif

#if	CONFIG_DEV_SPI_DAC082S085
#define	CONFIG_FUNC_SPI2	1
#else
#define	CONFIG_FUNC_SPI2	0
#endif

#if	CONFIG_DEV_SPI_TSC2046
#define	CONFIG_FUNC_SPI3	1
#else
#define	CONFIG_FUNC_SPI3	0
#endif

/* PWM */
#define	CONFIG_PWM_NUM		2
#if	CONFIG_DEV_PWM_BUZZER
#define	CONFIG_FUNC_PWM0	1
#else
#define	CONFIG_FUNC_PWM0	0
#endif

#if	CONFIG_DEV_PWM_SERVO
#define	CONFIG_FUNC_PWM1	1
#else
#define	CONFIG_FUNC_PWM1	0
#endif

#if	CONFIG_DEV_PWM_BACKLIGHT
#define	CONFIG_FUNC_PWM2	1
#else
#define	CONFIG_FUNC_PWM2	0
#endif


/* UART */
#define CONFIG_UART_NUM		2
#if CONFIG_DEV_UART_RS232C
#define CONFIG_FUNC_UART0	1
#else
#define CONFIG_FUNC_UART0	0
#endif

#if CONFIG_DEV_UART_USB
#define CONFIG_FUNC_UART1	1
#else
#define CONFIG_FUNC_UART1	0
#endif

/* TIMER */
#define	CONFIG_TIMER_NUM	3
#define CONFIG_FUNC_TIMER0	0
#define CONFIG_FUNC_TIMER1	1
#define CONFIG_FUNC_TIMER2	1

/* LCDC */
#if CONFIG_DEV_LCD
#define CONFIG_FUNC_LCDC	1
#else
#define CONFIG_FUNC_LCDC	0
#endif


#endif /* _CONFIG_H_ */
